xref: /openbmc/linux/scripts/kconfig/Makefile (revision 5927145e)
1# SPDX-License-Identifier: GPL-2.0
2# ===========================================================================
3# Kernel configuration targets
4# These targets are used from top-level makefile
5
6PHONY += xconfig gconfig menuconfig config silentoldconfig update-po-config \
7	localmodconfig localyesconfig
8
9ifdef KBUILD_KCONFIG
10Kconfig := $(KBUILD_KCONFIG)
11else
12Kconfig := Kconfig
13endif
14
15ifeq ($(quiet),silent_)
16silent := -s
17endif
18
19# We need this, in case the user has it in its environment
20unexport CONFIG_
21
22xconfig: $(obj)/qconf
23	$< $(silent) $(Kconfig)
24
25gconfig: $(obj)/gconf
26	$< $(silent) $(Kconfig)
27
28menuconfig: $(obj)/mconf
29	$< $(silent) $(Kconfig)
30
31config: $(obj)/conf
32	$< $(silent) --oldaskconfig $(Kconfig)
33
34nconfig: $(obj)/nconf
35	$< $(silent) $(Kconfig)
36
37# This has become an internal implementation detail and is now deprecated
38# for external use.
39silentoldconfig: $(obj)/conf
40	$(Q)mkdir -p include/config include/generated
41	$(Q)test -e include/generated/autoksyms.h || \
42	    touch   include/generated/autoksyms.h
43	$< $(silent) --$@ $(Kconfig)
44
45localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
46	$(Q)mkdir -p include/config include/generated
47	$(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
48	$(Q)if [ -f .config ]; then 					\
49			cmp -s .tmp.config .config ||			\
50			(mv -f .config .config.old.1;			\
51			 mv -f .tmp.config .config;			\
52			 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
53			 mv -f .config.old.1 .config.old)		\
54	else								\
55			mv -f .tmp.config .config;			\
56			$(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
57	fi
58	$(Q)rm -f .tmp.config
59
60# Create new linux.pot file
61# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
62update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
63	$(Q)$(kecho) "  GEN     config.pot"
64	$(Q)xgettext --default-domain=linux                         \
65	    --add-comments --keyword=_ --keyword=N_                 \
66	    --from-code=UTF-8                                       \
67	    --files-from=$(srctree)/scripts/kconfig/POTFILES.in     \
68	    --directory=$(srctree) --directory=$(objtree)           \
69	    --output $(obj)/config.pot
70	$(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
71	$(Q)(for i in `ls $(srctree)/arch/*/Kconfig      \
72	    $(srctree)/arch/*/um/Kconfig`;               \
73	    do                                           \
74		$(kecho) "  GEN     $$i";                    \
75		$(obj)/kxgettext $$i                     \
76		     >> $(obj)/config.pot;               \
77	    done )
78	$(Q)$(kecho) "  GEN     linux.pot"
79	$(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
80	    --output $(obj)/linux.pot
81	$(Q)rm -f $(obj)/config.pot
82
83# These targets map 1:1 to the commandline options of 'conf'
84simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
85	alldefconfig randconfig listnewconfig olddefconfig
86PHONY += $(simple-targets)
87
88$(simple-targets): $(obj)/conf
89	$< $(silent) --$@ $(Kconfig)
90
91PHONY += oldnoconfig savedefconfig defconfig
92
93# oldnoconfig is an alias of olddefconfig, because people already are dependent
94# on its behavior (sets new symbols to their default value but not 'n') with the
95# counter-intuitive name.
96oldnoconfig: olddefconfig
97	@echo "  WARNING: \"oldnoconfig\" target will be removed after Linux 4.19"
98	@echo "            Please use \"olddefconfig\" instead, which is an alias."
99
100savedefconfig: $(obj)/conf
101	$< $(silent) --$@=defconfig $(Kconfig)
102
103defconfig: $(obj)/conf
104ifeq ($(KBUILD_DEFCONFIG),)
105	$< $(silent) --defconfig $(Kconfig)
106else
107ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG)),)
108	@$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
109	$(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
110else
111	@$(kecho) "*** Default configuration is based on target '$(KBUILD_DEFCONFIG)'"
112	$(Q)$(MAKE) -f $(srctree)/Makefile $(KBUILD_DEFCONFIG)
113endif
114endif
115
116%_defconfig: $(obj)/conf
117	$(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
118
119configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
120
121%.config: $(obj)/conf
122	$(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
123	$(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
124	+$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
125
126PHONY += kvmconfig
127kvmconfig: kvm_guest.config
128	@:
129
130PHONY += xenconfig
131xenconfig: xen.config
132	@:
133
134PHONY += tinyconfig
135tinyconfig:
136	$(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
137
138# Help text used by make help
139help:
140	@echo  '  config	  - Update current config utilising a line-oriented program'
141	@echo  '  nconfig         - Update current config utilising a ncurses menu based'
142	@echo  '                    program'
143	@echo  '  menuconfig	  - Update current config utilising a menu based program'
144	@echo  '  xconfig	  - Update current config utilising a Qt based front-end'
145	@echo  '  gconfig	  - Update current config utilising a GTK+ based front-end'
146	@echo  '  oldconfig	  - Update current config utilising a provided .config as base'
147	@echo  '  localmodconfig  - Update current config disabling modules not loaded'
148	@echo  '  localyesconfig  - Update current config converting local mods to core'
149	@echo  '  defconfig	  - New config with default from ARCH supplied defconfig'
150	@echo  '  savedefconfig   - Save current config as ./defconfig (minimal config)'
151	@echo  '  allnoconfig	  - New config where all options are answered with no'
152	@echo  '  allyesconfig	  - New config where all options are accepted with yes'
153	@echo  '  allmodconfig	  - New config selecting modules when possible'
154	@echo  '  alldefconfig    - New config with all symbols set to default'
155	@echo  '  randconfig	  - New config with random answer to all options'
156	@echo  '  listnewconfig   - List new options'
157	@echo  '  olddefconfig	  - Same as oldconfig but sets new symbols to their'
158	@echo  '                    default value without prompting'
159	@echo  '  kvmconfig	  - Enable additional options for kvm guest kernel support'
160	@echo  '  xenconfig       - Enable additional options for xen dom0 and guest kernel support'
161	@echo  '  tinyconfig	  - Configure the tiniest possible kernel'
162
163# lxdialog stuff
164check-lxdialog  := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
165
166# Use recursively expanded variables so we do not call gcc unless
167# we really need to do so. (Do not call gcc as part of make mrproper)
168HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
169                    -DLOCALE
170
171# ===========================================================================
172# Shared Makefile for the various kconfig executables:
173# conf:	  Used for defconfig, oldconfig and related targets
174# nconf:  Used for the nconfig target.
175#         Utilizes ncurses
176# mconf:  Used for the menuconfig target
177#         Utilizes the lxdialog package
178# qconf:  Used for the xconfig target
179#         Based on Qt which needs to be installed to compile it
180# gconf:  Used for the gconfig target
181#         Based on GTK+ which needs to be installed to compile it
182# object files used by all kconfig flavours
183
184lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
185lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
186
187conf-objs	:= conf.o  zconf.tab.o
188mconf-objs     := mconf.o zconf.tab.o $(lxdialog)
189nconf-objs     := nconf.o zconf.tab.o nconf.gui.o
190kxgettext-objs	:= kxgettext.o zconf.tab.o
191qconf-cxxobjs	:= qconf.o
192qconf-objs	:= zconf.tab.o
193gconf-objs	:= gconf.o zconf.tab.o
194
195hostprogs-y := conf nconf mconf kxgettext qconf gconf
196
197targets		+= zconf.tab.c zconf.lex.c
198clean-files	:= qconf.moc .tmp_qtcheck .tmp_gtkcheck
199clean-files	+= zconf.tab.c zconf.lex.c gconf.glade.h
200clean-files     += config.pot linux.pot
201
202# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
203PHONY += $(obj)/dochecklxdialog
204$(addprefix $(obj)/, mconf.o $(lxdialog)): $(obj)/dochecklxdialog
205$(obj)/dochecklxdialog:
206	$(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
207
208always := dochecklxdialog
209
210# Add environment specific flags
211HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
212HOST_EXTRACXXFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCXX) $(HOSTCXXFLAGS))
213
214# generated files seem to need this to find local include files
215HOSTCFLAGS_zconf.lex.o	:= -I$(src)
216HOSTCFLAGS_zconf.tab.o	:= -I$(src)
217
218HOSTLOADLIBES_qconf	= $(KC_QT_LIBS)
219HOSTCXXFLAGS_qconf.o	= $(KC_QT_CFLAGS)
220
221HOSTLOADLIBES_gconf	= `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
222HOSTCFLAGS_gconf.o	= `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
223                          -Wno-missing-prototypes
224
225HOSTLOADLIBES_mconf   = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
226
227HOSTLOADLIBES_nconf	= $(shell \
228				pkg-config --libs menuw panelw ncursesw 2>/dev/null \
229				|| pkg-config --libs menu panel ncurses 2>/dev/null \
230				|| echo "-lmenu -lpanel -lncurses"  )
231$(obj)/qconf.o: $(obj)/.tmp_qtcheck
232
233ifeq ($(MAKECMDGOALS),xconfig)
234$(obj)/.tmp_qtcheck: $(src)/Makefile
235-include $(obj)/.tmp_qtcheck
236
237# Qt needs some extra effort...
238$(obj)/.tmp_qtcheck:
239	@set -e; $(kecho) "  CHECK   qt"; \
240	if pkg-config --exists Qt5Core; then \
241	    cflags="-std=c++11 -fPIC `pkg-config --cflags Qt5Core Qt5Gui Qt5Widgets`"; \
242	    libs=`pkg-config --libs Qt5Core Qt5Gui Qt5Widgets`; \
243	    moc=`pkg-config --variable=host_bins Qt5Core`/moc; \
244	elif pkg-config --exists QtCore; then \
245	    cflags=`pkg-config --cflags QtCore QtGui`; \
246	    libs=`pkg-config --libs QtCore QtGui`; \
247	    moc=`pkg-config --variable=moc_location QtCore`; \
248	else \
249	    echo >&2 "*"; \
250	    echo >&2 "* Could not find Qt via pkg-config."; \
251	    echo >&2 "* Please install either Qt 4.8 or 5.x. and make sure it's in PKG_CONFIG_PATH"; \
252	    echo >&2 "*"; \
253	    exit 1; \
254	fi; \
255	echo "KC_QT_CFLAGS=$$cflags" > $@; \
256	echo "KC_QT_LIBS=$$libs" >> $@; \
257	echo "KC_QT_MOC=$$moc" >> $@
258endif
259
260$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
261
262ifeq ($(MAKECMDGOALS),gconfig)
263-include $(obj)/.tmp_gtkcheck
264
265# GTK+ needs some extra effort, too...
266$(obj)/.tmp_gtkcheck:
267	@if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then		\
268		if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then			\
269			touch $@;								\
270		else									\
271			echo >&2 "*"; 							\
272			echo >&2 "* GTK+ is present but version >= 2.0.0 is required.";	\
273			echo >&2 "*";							\
274			false;								\
275		fi									\
276	else										\
277		echo >&2 "*"; 								\
278		echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; 	\
279		echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; 	\
280		echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; 		\
281		echo >&2 "*"; 								\
282		false;									\
283	fi
284endif
285
286$(obj)/zconf.tab.o: $(obj)/zconf.lex.c
287
288$(obj)/qconf.o: $(obj)/qconf.moc
289
290quiet_cmd_moc = MOC     $@
291      cmd_moc = $(KC_QT_MOC) -i $< -o $@
292
293$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
294	$(call cmd,moc)
295
296# Extract gconf menu items for i18n support
297$(obj)/gconf.glade.h: $(obj)/gconf.glade
298	$(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
299	$(obj)/gconf.glade
300